package svc

import (
	"applet/app/db"
	"applet/app/es/md"
	"applet/app/lib/haodanku"
	md2 "applet/app/task/md"
	"applet/app/utils"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_es.git/es"
	md3 "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/zhimeng"
	"fmt"
	"github.com/syyongx/php2go"
	"strings"
	"time"
)

func DataCollectCronHaodankuRealNews(types int) {
	key := md.ZhiosRealNewsData
	//es.CreateIndexIfNotExists(key, md.ZhiosRealNewsDataField)
	ids := []int{10001, 10002, 10003, 10004}
	num := 10
	if types == 0 {
		ids = []int{0}
		num = 3
	}
	size := 100
	now := time.Now()
	fmt.Println("============", time.Since(now))
	sysCfgDb := db.SysCfgDb{}
	sysCfgDb.Set()
	third_zm_app_key := sysCfgDb.SysCfgGetOneData("third_zm_app_key")
	third_zm_app_secret := sysCfgDb.SysCfgGetOneData("third_zm_app_secret")
	for _, v := range ids {
		for i := 1; i <= num; i++ {
			time.Sleep(time.Microsecond * 10) // 等待10毫秒

			tianMaoChaoZhiData, err := haodanku.HaodankuRealTime(utils.IntToStr(v), utils.IntToStr(i), utils.IntToStr(size), "")
			if err != nil {
				return
			}
			if tianMaoChaoZhiData == nil {
				continue
			}
			platformMap := map[string]string{
				"淘宝": "taobao",
				"天猫": "taobao",
				"京东": "jd",
			}
			for _, item := range tianMaoChaoZhiData {
				var tmp = md2.RealNewsData{
					Id:         utils.StrToInt(item.WireId),
					CateId:     utils.SerializeStr(item.CateId),
					Images:     utils.SerializeStr(item.Images),
					Platform:   item.Platform,
					StartTime:  utils.AnyToInt64(item.Starttime),
					OldContent: utils.SerializeStr(item.List),
				}
				tmp.Key = php2go.Md5("hdk_real_news_" + item.WireId)
				var uniqueId = tmp.Key
				doc, _ := es.FirstDoc(key, uniqueId)
				if doc == nil {
					goodsList := make([]map[string]string, 0)
					for k1, v1 := range item.List {
						if item.Platform == "1" {
							item.Platform = "淘宝"
						}
						if item.Platform == "2" {
							item.Platform = "京东"
						}
						if v1.ItemId != "" {
							tmp1 := map[string]string{
								"content":       "去购买>\n",
								"gid":           v1.ItemId,
								"is_click":      "1",
								"platform_type": platformMap[item.Platform],
								"url":           "",
							}
							if item.Platform == "京东" && strings.Contains(v1.ItemId, "http") {
								itemId := ""
								if strings.Contains(v1.ItemId, "jd.") {
									time.Sleep(time.Microsecond * 10) // 等待500毫秒
									//gid = decode
									postData := make(map[string]interface{})
									// 配置智盟 appkey 和 sk
									postData["appkey"] = third_zm_app_key
									postData["secret_key"] = third_zm_app_secret
									postData["size"] = "2"
									postData["p"] = "1"
									postData["is_url"] = "1"
									postData["keyword"] = v1.ItemId
									jdData, err := zhimeng.NewZhiMengJingDongSDK().
										SelectFunction("new_getgoods").
										WithArgs(postData).
										Result()
									if err == nil {
										itemInfo := &md3.MoreDetailResponse{}
										if err := jdData.ToStruct(itemInfo); err == nil {
											itemId = itemInfo.GID
											if itemInfo.GID == "" || itemInfo.GID == "100038437991" {
												itemId = ""
											}
										}
									} else {
										itemId = ""
									}
								}
								if itemId != "" {
									tmp1["gid"] = itemId
								} else {
									tmp1["gid"] = ""
									tmp1["is_click"] = "0"
									tmp1["content"] = "\n" + v1.ItemId + "\n"
								}
							}
							goodsList = append(goodsList, tmp1)
						} else {
							tmp1 := map[string]string{
								"content":       v1.Content,
								"gid":           "",
								"is_click":      "0",
								"platform_type": "",
								"url":           "",
							}
							if k1 > 0 {
								tmp1["content"] = "\n" + tmp1["content"]
							}
							goodsList = append(goodsList, tmp1)
						}
					}
					tmp.Content = utils.SerializeStr(goodsList)
					createDocRet, err := es.CreateDoc(key, uniqueId, tmp)
					if err != nil {
						return
					}
					fmt.Printf("CreateDoc ==> %+v \n\n", createDocRet)
				}

			}
		}

	}
	fmt.Println("==========================end", time.Since(now))
}
